timeout: 900s

# [START tf-init]
steps:
    - id: 'branch name'
      name: 'alpine'
      entrypoint: 'sh'  
      args: 
      - '-c'
      - | 
          echo "***********************"
          echo "$BRANCH_NAME"
          echo "***********************"
    - id: 'tf init'
      dir: infrastructure/terraform
      name: 'gcr.io/graphite-tesla-246507/gcloud-tf'
      entrypoint: 'sh'
      args: 
      - '-c'
      - |
          if [ -d "environments/$BRANCH_NAME/" ]; then
            cd environments/$BRANCH_NAME
            terraform init
          else
            for dir in environments/*/
            do 
              cd ${dir}   
              env=${dir%*/}
              env=${env#*/}
              echo ""
              echo "*************** TERRAFORM INIT ******************"
              echo "******* At environment: '$BRANCH_NAME' ********"
              echo "*************************************************"
              terraform init || exit 1
              cd ../../
            done
          fi

# [START tf-plan]
    - id: 'tf plan'
      dir: infrastructure/terraform
      name: 'gcr.io/graphite-tesla-246507/gcloud-tf'
      entrypoint: 'sh'
      args: 
      - '-c'
      - | 
          if [ -d "environments/$BRANCH_NAME/" ]; then
            cd environments/$BRANCH_NAME
            terraform plan
          else
            for dir in environments/*/
            do 
              cd ${dir}   
              env=${dir%*/}
              env=${env#*/}  
              echo ""
              echo "*************** TERRAFOM PLAN ******************"
              echo "******* At environment: '$BRANCH_NAME' ********"
              echo "*************************************************"
              terraform plan || exit 1
              cd ../../
            done
          fi 
    
# [START tf-apply]
    - id: 'tf apply'
      dir: infrastructure/terraform
      name: 'gcr.io/graphite-tesla-246507/gcloud-tf'
      entrypoint: 'sh'
      args: 
      - '-c'
      - | 
          if [ -d "environments/$BRANCH_NAME/" ]; then
            cd environments/$BRANCH_NAME     
            terraform apply -auto-approve
          else
            echo "***************************** SKIPPING APPLYING *******************************"
            echo "Branch '$BRANCH_NAME' does not represent an oficial environment."
            echo "*******************************************************************************"
          fi
